
local bt = {speed=1/2}

local merges = {}

function bt.reset(maze,width,height)
	merges = {}
	local x,y = math.random(1,width),math.random(1,height)
	if x > 1 then
		merges[#merges+1] = {x,y,x-1,y}
	end
	if y > 1 then
		merges[#merges+1] = {x,y,x,y-1}
	end
	if x < width then
		merges[#merges+1] = {x,y,x+1,y}
	end
	if y < height then
		merges[#merges+1] = {x,y,x,y+1}
	end
end

local function count(l,u,r,d)
	local c = 0
	if l then c=c+1 end
	if u then c=c+1 end
	if r then c=c+1 end
	if d then c=c+1 end
	return c
end

local function connected(maze,x1,y1,x2,y2)
	local l,u,r,d = maze:get(x1,y1)
	if x1 < x2 then
		return r
	elseif x1 > x2 then
		return l
	elseif y1 < y2 then
		return d
	elseif y1 > y2 then
		return u
	end
end

function bt.update(maze)
	if #merges > 0 then
		local c = math.random(1,#merges)
		local x1,y1,x2,y2 = unpack(merges[c])
		if maze:getRaw(x1,y1) == 0 or maze:getRaw(x2,y2) == 0 or count(maze:get(x1,y1)) <= 1 or count(maze:get(x2,y2)) <= 1 then
			if not connected(maze,x1,y1,x2,y2) then
				maze:merge(x1,y1,x2,y2)
				local l,u,r,d = maze:get(x2,y2)
				if x2 > 1 and (maze:getRaw(x2-1,y2) == 0 or count(maze:get(x2-1,y2)) <= 1) and not l then
					merges[#merges+1] = {x2,y2,x2-1,y2}
				end
				if y2 > 1 and (maze:getRaw(x2,y2-1) == 0 or count(maze:get(x2,y2-1)) <= 1) and not u then
					merges[#merges+1] = {x2,y2,x2,y2-1}
				end
				if x2 < maze.width and (maze:getRaw(x2+1,y2) == 0 or count(maze:get(x2+1,y2)) <= 1) and not r then
					merges[#merges+1] = {x2,y2,x2+1,y2}
				end
				if y2 < maze.height and (maze:getRaw(x2,y2+1) == 0 or count(maze:get(x2,y2+1)) <= 1) and not d then
					merges[#merges+1] = {x2,y2,x2,y2+1}
				end
			end
		end
		table.remove(merges,c)
	end
end

return bt
