
local bt = {speed=5/1}

local paths = {}
local extendChance = 0.02

function bt.reset(maze,width,height)
	paths = {{math.random(1,width),math.random(1,height)}}
end

local surrounds = {
	{x=-1,y= 0},
	{x= 1,y= 0},
	{x= 0,y= 1},
	{x= 0,y=-1},
}

local function update(maze,path)
	if #path > 0 then
		local t = {}
		local x,y = path[#path-1],path[#path]
		for i,v in pairs(surrounds) do
			if maze:getRaw(x+v.x,y+v.y) == 0 then
				t[#t+1] = {x+v.x,y+v.y}
			end
		end
		if #t > 0 then
			local c = math.random(1,#t)
			maze:merge(x,y,t[c][1],t[c][2])
			if math.random() < extendChance then
				paths[#paths+1] = {}
				paths[#paths][1] = t[c][1]
				paths[#paths][2] = t[c][2]
			else
				path[#path+1] = t[c][1]
				path[#path+1] = t[c][2]
			end
		else
			path[#path]=nil
			path[#path]=nil
		end
	end
end

function bt.update(maze)
	for i,v in pairs(paths) do
		update(maze,v)
	end
end

return bt
