
local bt = {speed=1/2}

local merges = {}
local cMap = {}

function bt.reset(maze,width,height)
	for i,v in pairs(merges) do
		merges[i] = nil
	end
	for i = 1, height do
		cMap[i] = {}
		for j = 1, width do
			cMap[i][j] = i*width+j
			if i < height then
				merges[#merges+1] = {j,i,j,i+1}
			end
			if j < width then
				merges[#merges+1] = {j,i,j+1,i}
			end
		end
	end
end

local function fill(a,b)
	for i,v in pairs(cMap) do
		for j,w in pairs(v) do
			if v[j] == a then v[j] = b end
		end
	end
end

function bt.update(maze)
	if #merges > 0 then
		local c = math.random(1,#merges)
		local x1,y1,x2,y2 = unpack(merges[c])
		if cMap[y1][x1] ~= cMap[y2][x2] then
			maze:merge(x1,y1,x2,y2)
			fill(cMap[y1][x1],cMap[y2][x2])
		end
		table.remove(merges,c)
	end
end

return bt
