
local bt = {speed=3/4}

local merges = {}

function bt.reset(maze,width,height)
	merges = {}
	local x,y = math.random(1,width),math.random(1,height)
	if x > 1 then
		merges[#merges+1] = {x,y,x-1,y}
	end
	if y > 1 then
		merges[#merges+1] = {x,y,x,y-1}
	end
	if x < width then
		merges[#merges+1] = {x,y,x+1,y}
	end
	if y < height then
		merges[#merges+1] = {x,y,x,y+1}
	end
end

function bt.update(maze)
	if #merges > 0 then
		local c = math.random(1,#merges)
		local x1,y1,x2,y2 = unpack(merges[c])
		if maze:getRaw(x1,y1) == 0 or maze:getRaw(x2,y2) == 0 then
			maze:merge(x1,y1,x2,y2)
			if x2 > 1 and maze:getRaw(x2-1,y2) == 0 then
				merges[#merges+1] = {x2,y2,x2-1,y2}
			end
			if y2 > 1 and maze:getRaw(x2,y2-1) == 0 then
				merges[#merges+1] = {x2,y2,x2,y2-1}
			end
			if x2 < maze.width and maze:getRaw(x2+1,y2) == 0 then
				merges[#merges+1] = {x2,y2,x2+1,y2}
			end
			if y2 < maze.height and maze:getRaw(x2,y2+1) == 0 then
				merges[#merges+1] = {x2,y2,x2,y2+1}
			end
		end
		table.remove(merges,c)
	end
end

return bt
