
local maze = {}

local left,up,right,down = 1,2,4,8

local function calc(maze,n)
	maze.preCalc = {}
	local preCalc = maze.preCalc
	for i = 0, n do
		preCalc[i] = {}
		local a = i
		for j = #maze.flags,1,-1 do
			if math.mod(a,#maze.flags[j]) ~= a then
				local name = ''
				for k,v in pairs(maze.flags) do
					if type(k) ~= 'number' then
						if v == #maze.flags[j] then
							name = k
						end
					end
				end
				preCalc[i][k] = true
				a=math.mod(a,#maze.flags)
			end
		end
		if math.mod(a,down) ~= a then
			preCalc[i].down = true
			a=math.mod(a,down)
		else
			preCalc[i].down = false
		end
		if math.mod(a,right) ~= a then
			preCalc[i].right = true
			a=math.mod(a,right)
		else
			preCalc[i].right = false
		end
		if math.mod(a,up) ~= a then
			preCalc[i].up = true
			a=math.mod(a,up)
		else
			preCalc[i].up = false
		end
		if math.mod(a,left) ~= a then
			preCalc[i].left = true
		else
			preCalc[i].left = false
		end
	end
end

local function mazeGetRaw(maze,x,y)
	if maze.map[y] then
		if maze.map[y][x] then
			return maze.map[y][x]
		elseif x >= 1 and y >= 1 and x <= maze.width and y <= maze.height then
			return 0
		end
	elseif x >= 1 and y >= 1 and x <= maze.width and y <= maze.height then
		return 0
	end
end
local function mazeSetRaw(maze,x,y,v)
	if not maze.width or (x >= 1 and y >= 1 and x <= maze.width and y <= maze.height) then
		maze.map[y] = maze.map[y] or {}
		maze.map[y][x] = v
		if maze.setRawCallback then maze.setRawCallback(x,y,v) end
	end
end

local function mazeGet(maze,x,y)
	if maze.map[y] then
		if maze.map[y][x] then
			local p = maze.preCalc[maze.map[y][x]]
			return p.left,p.up,p.right,p.down
		elseif not maze.width or (x >= 1 and y >= 1 and x <= maze.width and y <= maze.height) then
			return false,false,false,false
		end
	elseif not maze.width or (x >= 1 and y >= 1 and x <= maze.width and y <= maze.height) then
		return false,false,false,false
	end
end
local function mazeSet(maze,x,y,l,u,r,d)
	local i = 0
	if l then i=i + left	end
	if u then i=i + up		end
	if r then i=i + right	end
	if d then i=i + down	end
	mazeSetRaw(maze,x,y,i)
	if maze.setCallback then maze.setCallback(x,y,v) end
end

local function mazeConnected(maze,x,y)
	if maze.map[y] and maze.map[y][x] then
		local t = {}
		local i = maze.preCalc[mazeGetRaw(maze,x,y)]
		if i.left then
			t[#t+1] = {x=x-1,y=y}
		end
		if i.up then
			t[#t+1] = {x=x,y=y-1}
		end
		if i.right then
			t[#t+1] = {x=x+1,y=y}
		end
		if i.down then
			t[#t+1] = {x=x,y=y+1}
		end
		return t
	else
		error('Bad position')
	end
end

local function mazeNotConnected(maze,x,y)
	if maze.map[y] and maze.map[y][x] then
		local t = {}
		local i = maze.preCalc[mazeGetRaw(maze,x,y)]
		if not i.left then
			t[#t+1] = {x=x-1,y=y}
		end
		if not i.up then
			t[#t+1] = {x=x,y=y-1}
		end
		if not i.right then
			t[#t+1] = {x=x+1,y=y}
		end
		if not i.down then
			t[#t+1] = {x=x,y=y+1}
		end
		return t
	else
		error('Bad position')
	end
end

local function mazeNearby(maze,x,y)
	if maze.map[y] and maze.map[y][x] then
		local t = {}
		t[#t+1] = {x=x-1,y=y}
		t[#t+1] = {x=x,y=y-1}
		t[#t+1] = {x=x+1,y=y}
		t[#t+1] = {x=x,y=y+1}
		return t
	else
		error('Bad position')
	end
end

local function mazeLeft(maze,x,y)
	return maze.preCalc[mazeGetRaw(maze,x,y)].left
end
local function mazeUp(maze,x,y)
	return maze.preCalc[mazeGetRaw(maze,x,y)].up
end
local function mazeRight(maze,x,y)
	return maze.preCalc[mazeGetRaw(maze,x,y)].right
end
local function mazeDown(maze,x,y)
	return maze.preCalc[mazeGetRaw(maze,x,y)].down
end

local function mazeMerge(maze,x1,y1,x2,y2)
	if mazeGetRaw(maze,x1,y1) and mazeGetRaw(maze,x2,y2) then
		if x1 < x2 then
			mazeSetRaw(maze,x1,y1,mazeGetRaw(maze,x1,y1)+right)
			mazeSetRaw(maze,x2,y2,mazeGetRaw(maze,x2,y2)+left)
		elseif x1 > x2 then
			mazeSetRaw(maze,x1,y1,mazeGetRaw(maze,x1,y1)+left)
			mazeSetRaw(maze,x2,y2,mazeGetRaw(maze,x2,y2)+right)
		elseif y1 < y2 then
			mazeSetRaw(maze,x1,y1,mazeGetRaw(maze,x1,y1)+down)
			mazeSetRaw(maze,x2,y2,mazeGetRaw(maze,x2,y2)+up)
		elseif y1 > y2 then
			mazeSetRaw(maze,x1,y1,mazeGetRaw(maze,x1,y1)+up)
			mazeSetRaw(maze,x2,y2,mazeGetRaw(maze,x2,y2)+down)
		end
	else
		error('Bad merge')
	end
end

local function mazeNewFlag(maze,name)
	local i = 2^(4+#maze.flags)
	maze.flags[#maze.flags+1] = i
	maze.flags[name] = i
	calc(maze,i*2-1)
	maze['get' .. string.upper(string.sub(name,1,1)) .. string.sub(name,2)] = function(maze,x,y)
		return maze.preCalc[mazeGetRaw(maze,x,y)][name]
	end
end

function maze.newMaze(width,height)
	local self = {}

	self.flags = {}
	self.map = {}
	calc(self,15)
	if width and height then -- Only specify width/height if both are present
		self.width = width
		self.height = height
	end

	-- Checks, all of them take X and Y they all return true if the block have the current flag
	self.left	= mazeLeft
	self.up		= mazeUp
	self.right	= mazeRight
	self.down	= mazeDown
	self.get	= mazeGet -- Returns left,up,right,down

	self.newFlag = mazeNewFlag

	-- Sets
	self.merge	= mazeMerge -- Merge two blocks ( need to be adjecant )
	self.set	= mazeSet -- Should not be used as it can cause inconsistience

	-- Raw sets, Allows you to set the number by yourself ( set should not be used )
	self.getRaw	= mazeGetRaw
	self.setRaw	= mazeSetRaw

	-- Those its connected to ( It will say those goes to from the block )
	self.connected	= mazeConnected
	-- The reverso o connected
	self.notConnected = mazeNotConnected
	-- Those its nearby IE left,up,right,down
	self.nearby		= mazeNearby

	return self
end

return maze
